﻿
@{
    ViewBag.Title = "Merchant List";
}
<!-- Content Header (Page header) -->
<section class="content-header">
    <h1>
        Master
        <small>Merchants</small>
    </h1>
    <ol class="breadcrumb">
        <li><a href="/"><i class="fa fa-dashboard"></i> Home</a></li>
        <li class="active">Merchants</li>
    </ol>
</section>
<!-- Main content -->
<section class="content">
    <div id="data-list" class="box">
        <div class="box-header with-border">
            <h3 class="box-title">Merchant List</h3>
            <div class="box-tools pull-right">
                <button type="button" class="btn btn-box-tool" data-widget="collapse" data-toggle="tooltip"
                        title="Collapse">
                    <i class="fa fa-minus"></i>
                </button>
                <button type="button" class="btn btn-box-tool" data-widget="remove" data-toggle="tooltip" title="Remove">
                    <i class="fa fa-times"></i>
                </button>
            </div>
        </div>
        <div class="box-body">
            <div id="grid-merchant"></div>
        </div>
        <!-- /.box-body -->
        <div class="box-footer text-right">
            <button id="btn-add" type="button" class="btn btn-primary"><i class="fa fa-plus"></i> Add New</button>
        </div>
        <!-- /.box-footer-->
    </div>
    <!-- /.box -->
    <div id="data-detail" class="box" style="display: none">
        <form name="form1">
            <div class="box-header with-border">
                <h3 class="box-title">Merchant Detail</h3>
                <div class="box-tools pull-right">
                    <button type="button" class="btn btn-box-tool" data-widget="collapse" data-toggle="tooltip"
                            title="Collapse">
                        <i class="fa fa-minus"></i>
                    </button>
                    <button type="button" class="btn btn-box-tool" data-widget="remove" data-toggle="tooltip" title="Remove">
                        <i class="fa fa-times"></i>
                    </button>
                </div>
            </div>
            <div class="box-body">
                <div class="form-horizontal">
                    <div class="form-group">
                        <div class="col-md-2 control-label">Merchant ID</div>
                        <div class="col-md-3">
                            <input data-bind="MerchantID" type="text" name="MerchantID" class="form-control" readonly/>
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="col-md-2 control-label">Merchant Name</div>
                        <div class="col-md-3">
                            <input data-bind="MerchantName" type="text" name="MerchantName" class="form-control" />
                        </div>
                        <div class="col-md-2 control-label">Description</div>
                        <div class="col-md-3">
                            <input data-bind="Description" type="text" name="Description" class="form-control" />
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="col-md-2 control-label">Contact Name</div>
                        <div class="col-md-3">
                            <input data-bind="ContactName" type="text" name="ContactName" class="form-control" />
                        </div>
                        <div class="col-md-2 control-label">Address</div>
                        <div class="col-md-3">
                            <input data-bind="Address" type="text" name="Address" class="form-control" />
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-2 control-label">City</div>
                        <div class="col-md-3">
                            <input data-bind="City" type="text" name="City" class="form-control" />
                        </div>
                        <div class="col-md-2 control-label">Postal Code</div>
                        <div class="col-md-3">
                            <input data-bind="PostalCode" type="text" name="PostalCode" class="form-control" />
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-2 control-label">Email</div>
                        <div class="col-md-3">
                            <input data-bind="Email" type="email" name="Email" class="form-control" />
                        </div>
                        <div class="col-md-2 control-label">Phone</div>
                        <div class="col-md-3">
                            <input data-bind="Phone" type="text" name="Phone" class="form-control" />
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-2 control-label">Account ID</div>
                        <div class="col-md-3">
                           <div class="input-group">
                               <input data-bind="AccountID" type="text" name="AccountID" class="form-control" readonly/>
                               <div class="input-group-btn">
                                   <button id="btn-select-account" type="button" class="btn btn-primary"><i class="fa fa-user"></i></button>
                               </div>
                           </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="box-footer text-center">
                <button id="btn-back" type="button" class="btn btn-default"><i class="fa fa-chevron-left"></i> Back</button>
                <button id="btn-save" type="button" class="btn btn-primary"><i class="fa fa-save"></i> Save</button>
            </div>
        </form>
    </div>
</section>
<!-- /.content-->

<div id="select-account" class="modal fade">
    <div class="modal-dialog modal-lg">
        <div class="modal-body">
            <div class="box box-primary">
                <div class="box-header with-border">
                    Select Account
                    <span class="close" style="color: white; opacity:1" data-dismiss="modal">&times;</span>
                </div>
                <div class="box-body">
                    <div id="grid-account"></div>
                </div>
                <div class="box-footer text-center">
                    <button type="button" class="btn btn-default" data-dismiss="modal">
                        <i class="fa fa-remove"></i> Close
                    </button>
                </div>
            </div>
        </div>
    </div>
</div>


@section scripts
{
    <script>
    (function () {
        function Merchant() {
            return {
                MerchantID: 0,
                MerchantName: '',
                Description: '',
                ContactName: '',
                Address: '',
                City: '',
                PostalCode: '',
                Email: '',
                Phone: '',
                AccountID: ''
            }
        }
        var scope = (function () {
            return Bind({
                merchant: new Merchant()
            }, {
                    "merchant.MerchantID": "[data-bind='MerchantID']",
                    "merchant.MerchantName": "[data-bind='MerchantName']",
                    "merchant.Description": "[data-bind='Description']",
                    "merchant.ContactName": "[data-bind='ContactName']",
                    "merchant.Address": "[data-bind='Address']",
                    "merchant.City": "[data-bind='City']",
                    "merchant.PostalCode": "[data-bind='PostalCode']",
                    "merchant.Email": "[data-bind='Email']",
                    "merchant.Phone": "[data-bind='Phone']",
                    "merchant.AccountID": "[data-bind='AccountID']"
                });
        }());

        var gridAccount = gridview("grid-account", {
            url: "/Account/Paging",
            columns: [
                {
                    text: "", render: function (c) {
                        var tmpl = "<a action='select'><i class='fa fa-check'></i></a>";
                        return tmpl;
                    }
                },
                { field: "AccountID", text: "Account ID", sortable: true },
                { field: "FirstName", text: "First tName", sortable: true },
                { field: "Email", text: "Email", sortable: true },
                { field: "DateOfBirth", text: "Date Of Birth", sortable: true },
                { field: "IDNumber", text: "ID Number", sortable: true },
                { field: "Address", text: "Address", sortable: true },
                { field: "City", text: "City", sortable: true }
            ],
            fieldKey: "AccountID",
            select: function (acc) {
                scope.merchant.AccountID = acc.AccountID;
                scope.merchant = acc;
                $("#select-account").modal("hide");
            },
        });

        var state = "new";

        var grid = gridview("grid-merchant", {
            url: "/Merchant/Paging",
            columns: [
                {
                    text: "", render: function (c) {
                        var tmpl = "<a action='view'><i class='fa fa-search'></i></a>";
                        tmpl += "<a action='edit'><i class='fa fa-edit'></i></a>";
                        tmpl += "<a action='remove'><i class='fa fa-trash'></i></a>";
                        return tmpl;
                    }
                },
                { field: "MerchantID", text: "Merchant ID", sortable: true },
                { field: "MerchantName", text: "Merchant Name", sortable: true },
                { field: "Description", text: "Description", sortable: true },
                { field: "ContactName", text: "Contact tName", sortable: true },
                { field: "Address", text: "Address", sortable: true },
                { field: "City", text: "City", sortable: true },
                { field: "PostalCode", text: "Postal Code", sortable: true },
                { field: "Email", text: "Email", sortable: true }
            ],
            fieldKey: "MerchantID",
            view: view,
            edit: edit,
            remove: remove
        });

        function view(mrc) {
            scope.merchant = mrc;
            showDetail();
            $("[data-bind]").attr("disabled", true);
            $("#btn-save").hide();
        }

        function edit(mrc) {
            state = "update";
            scope.merchant = mrc;
            showDetail();
            $("[data-bind]").attr("disabled", false);
            $("[data-bind='MerchantID']").attr("disabled", true);
            $("#btn-save").show();
        }

        function addNew() {
            state = "new";
            scope.merchant = new Merchant();
            showDetail();
            $("[data-bind]").attr("disabled", false);
            $("#btn-save").show();
        }

        function remove(mrc) {
            Swal.fire({
                title: "Confirmation",
                text: "Are you sure?",
                type: "warning",
                showCancelButton: true,
                confirmButtonText: "YES",
                cancelButtonText: "NO",
                confirmButtonColor: "red"
            })
                .then(function (r) {
                    if (r.value) {
                        axios.post("/Merchant/Delete", { id: mrc.MerchantID })
                            .then(function (res) { return res.data; }, function (err) { console.log("Err: ", er); })
                            .then(function (res) {
                                if (res.meta.success) {
                                    Swal.fire("Success", "Delete data success", "success")
                                        .then(function (r) {
                                            grid.reload();
                                        });
                                } else {
                                    Swal.fire("Error", res.meta.message, "error");
                                }
                            });
                    }
                })
        }

        function showDetail() {
            $("#data-list").fadeOut(250, function () { $("#data-detail").fadeIn(500) });
        }

        function showList() {
            $("#data-detail").fadeOut(250, function () { $("#data-list").fadeIn(500) });
        }

        function save() {
            var url = "/Merchant/" + (state === "new" ? "Insert" : "Update");

            axios.post(url, { merchant: scope.merchant })
                .then(function (res) { return res.data; }, function (err) { console.log("Err: ", er); })
                .then(function (res) {
                    if (res.meta.success) {
                        Swal.fire("Success", "Save data success", "success")
                            .then(function (r) {
                                showList();
                                grid.reload();
                            });
                    } else {
                        Swal.fire("Error", res.meta.message, "error");
                    }
                });
        }

        $("#btn-select-account").click(function () { $("#select-account").modal(); });
        $("#btn-add").click(addNew);
        $("#btn-back").click(function () { showList(); });
        $("#btn-save").click(save);
    }());
    </script>
}